conjgrad = function(b, tol=1e-8) {

  n = DATA$n
  d = DATA$d
  
  result = rep(0, n)

  x0 = x = rep(0, n)

Ax = rep(0, n)
r = b - Ax

p = r
  rsold = as.double(t(r) %*% r)
  
  for (k in 1:100000) {
    cat(k, "    ")
    
    res = .C("covariance_matrix_vector_multiplication_fast_cmvps", as.double(DATA$X), as.integer(n), as.integer(d), as.double(theta), as.double(exp_theta), as.double(OMEGA), as.double(p), as.double(result), as.integer(TYPE), as.double(TOL_REL), as.double(TOL_ABS))
    Ap = res[[8]] # A %*% p
   
    alpha = rsold / as.double((t(p) %*% Ap))

    x = x + alpha * p
    r = r - alpha * Ap

    rsnew = as.double(t(r) %*% r)
    cat(sqrt(rsnew), "    \r")
    if (sqrt(rsnew) < tol) break

    p = r + rsnew / rsold * p

    rsold = rsnew
  }

  NITERATIONS <<- k
  cat(k, "\n")

  x
}

DATASET = "concrete"

## SEED_VAR = 3
## APPROX_NAME = c("NAIVE", "ANCHORS", "KDTREE")[3]

dyn.load("wrapped.so")

TYPE = which(c("NAIVE", "ANCHORS", "KDTREE") == APPROX_NAME)
TOL_REL = 1e-10
TOL_ABS = 1e-10

## ******************** DATASET
if(DATASET == "concrete") {
DATA = new.env()
DATA$X = t(as.matrix(read.table("~/DATASET_REGRESSION/clean/concrete_X.txt")))
DATA$y = as.matrix(read.table("~/DATASET_REGRESSION/clean/concrete_y.txt"))
}

## DATA$X = t(as.matrix(read.table("~/DATASET_REGRESSION/clean/census8L_X.txt")[1:1000,]))
## DATA$y = as.matrix(read.table("~/DATASET_REGRESSION/clean/census8L_y.txt"))[1:1000]

DATA$n = dim(DATA$X)[2]
DATA$d = dim(DATA$X)[1]

## ****************************************

OMEGA = 1e-9

SEEDS = c(as.matrix(read.table("LIST_SEEDS.txt")))[SEED_VAR] ## 1421812 + 7 * SEED_VAR
NREP = 1
plot.niterations1 = plot.niterations2 = rep(0, NREP)
plot.condition = rep(0, NREP)
plot.norm2.error = rep(0, NREP)

for(repetition in 1:NREP) {
  cat("\n", repetition, "\n")

  set.seed(SEEDS[repetition])

  theta = log(rgamma(3, 0.3, 0.01))
  exp_theta = exp(theta)

  K = exp(theta[1]) * exp( - exp(theta[3]) * as.matrix(dist(t(DATA$X))^2)) + diag(exp(theta[2]) + 1e-9, DATA$n)
  lambda = eigen(K, symmetric=T, only.values=T)[[1]]
  plot.condition[repetition] = lambda[1] / lambda[DATA$n]
  
  res_linear_system = conjgrad(DATA$y)
  plot.niterations1[repetition] = NITERATIONS

  L = t(chol(K))
  plot.norm2.error[repetition] = sum((res_linear_system - backsolve(t(L), forwardsolve(L, DATA$y)))^2)
  
  ## rvect = sample(c(-1,1), DATA$n, replace=T)
  ## res = .C("wrapper_linear_system", as.double(DATA$X), as.integer(DATA$n), as.integer(DATA$d), as.double(theta), as.double(exp_theta), as.double(OMEGA), as.double(rvect), as.integer(n_results), as.double(result), as.double(THRS_CONVERGENCE_CG), as.double(THRS_EARLY_STOP_CG), as.double(DECAY_EARLY_STOP_CG), as.integer(niterations))
  ## plot.niterations2[repetition] = res[[13]]

## cat("Condition number: ", condition.number, "\n\n")

  filesave = paste("RES_", DATASET, "_", APPROX_NAME, "_", SEEDS[repetition], ".txt", sep="")
  
  cat(theta, plot.condition[repetition], " ", plot.niterations1[repetition], " ", plot.norm2.error[repetition], "\n", file=filesave)
}


par(mfrow = c(1,2))
plot(log10(plot.condition), log10(plot.niterations1), pch=20)
plot(log10(plot.condition), log10(plot.norm2.error), pch=20)



## theta = rnorm(3)
## exp_theta = exp(theta)



## K = exp(theta[1]) * exp( - exp(theta[3]) * as.matrix(dist(t(DATA$X))^2)) + diag(exp(theta[2]) + OMEGA, DATA$n)
## zz = solve(K, DATA$y)

## print(range(res_linear_system - zz))
