/*
 * N-Body Methods
 * Copyright (C) 2006 Dustin Lang, Mike Klass, Firas Hamze, Anthony Lee
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#include "doublelist.h"
#include "definitions.h"

doublelist* doublelist_new() {
    doublelist* dl = (doublelist*) malloc(sizeof(doublelist));
    dl->size = 0;
    dl->capacity = 128;
    dl->array = (double*) malloc(dl->capacity * sizeof(double));
    return dl;
}

void doublelist_free(doublelist* dl) {
    free(dl->array);
    free(dl);
    dl = NULL;
}

void doublelist_copy(doublelist* dl, int num, double* dest) {
    int i;
	for (i = 0; i < num; i++) {
        dest[i] = dl->array[i];
    }
}

void doublelist_increase_capacity(doublelist* dl) {
    dl->capacity *= 2;
    dl->array = (double*) realloc(dl->array, dl->capacity * sizeof(double));
}

void doublelist_append(doublelist* dl, double d) {
    if (dl->size == dl->capacity) {
        doublelist_increase_capacity(dl);
    }
    dl->array[dl->size] = d;
    dl->size++;
}
