/*
 * N-Body Methods
 * Copyright (C) 2006 Dustin Lang, Mike Klass, Firas Hamze, Anthony Lee
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
 
#ifndef GAUSS_H_
#define GAUSS_H_
 

void gausst(double* xat, double* yat, double* zat, double* str, int
	    natoms, double* xtarg, double* ytarg, double* ztarg,
	    double* pot, int ntarg, double delta, double tol, int
	    nterms);

void gdir(double xp, double yp, double zp, double* xat, double* yat,
	  double* zat, int natoms, double* str, double* dpot, double
	  delta);

void gamval(double*** ffexp, int nterms, double* cent, double xpoint,
	    double ypoint, double zpoint, double* pot, double delta);

void gamkxp(double* cent, double* xatoms, double* yatoms, double* zatoms,
	    double* str, int ninbox, double*** ffexp, int nterms,
	    double delta);

void galval(double*** local, int nterms, double* cent, double xpoint,
	    double ypoint, double zpoint, double* pot, double delta);

void galkxp(double* cent, double xp, double yp, double zp, double
	    charge, double*** b, int nterms, double delta);

void gaeval(double* xtarg, double* ytarg, double* ztarg, double* pot,
	    int ntarg, double**** locexp, int nterms, int* ibox,
	    double* center, double delta, int* iloc, int nlmax, int
	    nside, int* itofst, int* itradr);

void gafexp(double* xat, double* yat, double* zat, double* str, int
	    natoms, double* xtarg, double* ytarg, double* ztarg, int
	    ntarg, double delta, int nside, int nterms, double tol,
	    int* iloc, int ntbox, int nfmax, int nlmax, double* pot,
	    int kdis, int* ibox, int* itradr, int* itofst, double*
	    center, double**** locexp);

void addexp(double***b, double***a, int nterms);

void assign(int nside, double* xat, double* yat, double* zat, double*
	    str, double* xatoms, double* yatoms, double* zatoms,
	    double* charg2, int* ioffst, double* xtarg, double*
	    ytarg, double* ztarg, int ntarg, int* ibox, int natoms,
	    double* center, int* itradr, int* itofst);

void freestuff(int* iloc, int* ibox, int* itofst, int* itradr,
	       double**** locexp, double* center, int nterms, int
	       ntbox);

void gshift(double*** ffexp, double* cent1, double* cent2, double***
	    local, int nterms, double*** temp1, double*** temp2,
	    double delta);


void mknbor(int ibox, int* nbors, int* nnbors, int nside, double
	    kdis);


void lenchk(int nside, double* xtarg, double* ytarg, double* ztarg,
	    int ntarg, int nterms, int nmax, int** iloc, int** ibox,
	    int** itofst, int** itradr, double***** locexp, double**
	    center, int* ntbox);

void gaussth(double *X, double *Y, double *w, double* kparams, int NP, char* ker_type,
             int NX, int NY, int D, double* bests, double eps_abs);

#endif /*GAUSS_H_*/
