PAR = list()

PAR$APPROX_NAME = c("ANCHORS", "KDTREE")
PAR$SEED_VAR = c(1:100)

sourcename = "conjugate_gradient_kitchen_sinks.r"

rscriptbasename = "rsc"

shscriptbasename = "shsc"

allscriptname = "runall.sh"

GRID = expand.grid(PAR)

for(i in 1:(dim(GRID)[1]))
  {
    comando = ""
    for(j in 1:length(PAR))
      {
        if(!is.numeric(GRID[i,j])) comando = paste(comando, names(PAR)[j],  "=\"", GRID[i,j], "\"; ", sep="")
        if(is.numeric(GRID[i,j])) comando = paste(comando, names(PAR)[j],  "=", GRID[i,j], "; ", sep="")        
      }
    comando = paste(comando,  "source(\"", sourcename, "\")\n", sep="")

    rfilename = paste(rscriptbasename, i, sep="")
    cat(comando, file=rfilename)
    cat("\nsystem(command=\"touch COMPLETED", i, "\")\n\n", file=rfilename, append=T, sep="")
    
    shfilename = paste(shscriptbasename, i, sep="")
    cat("#!/bin/bash\n\n", file=shfilename)

    cat("R CMD BATCH --no-restore --no-save ", rfilename, "\n", sep="", file=shfilename, append=T)

    cat("qsub -q short.q -cwd ", shfilename, "\n", sep="", file=allscriptname, append=T)
  }
