/*
 * N-Body Methods
 * Copyright (C) 2006 Dustin Lang, Mike Klass, Firas Hamze, Anthony Lee
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef GENERIC_MAX_H_
#define GENERIC_MAX_H_

#include "generic.h"

/* The main attraction. */
void generic_max(tree_globals* globals, Node* Xroot, Node* Yroot);

/* A convenience function for computing the "maxweight"s and computing
   the weight-sorted indices at each leaf node.  You probably want to
   call this just before calling "generic_max".  See the example in
   "anchor_max" and "boxtree_max". */
void generic_max_decorate_x_tree(Node* node, double* w, tree_globals* globals);

#endif /*GENERIC_MAX_H_*/
