/*
 * N-Body Methods
 * Copyright (C) 2006 Dustin Lang, Mike Klass, Firas Hamze, Anthony Lee
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#include "intlist.h"
#include "definitions.h"

intlist* intlist_new() {
    intlist* il = (intlist*) malloc(sizeof(intlist));
    il->size = 0;
    il->capacity = 128;
    il->array = (int*) malloc(il->capacity * sizeof(int));
    return il;
}

void intlist_free(intlist* il) {
    free(il->array);
    free(il);
    il = NULL;
}

int intlist_size(intlist* il) {
    return il->size;
}

void intlist_copy(intlist* il, int num, int* dest) {
    int i;
	for (i = 0; i < num; i++) {
        dest[i] = il->array[i];
    }
}

int intlist_get(intlist* il, int index) {
    return il->array[index];
}

void intlist_remove_all(intlist* il) {
    il->size = 0;
}

void intlist_increase_capacity(intlist* il) {
    il->capacity *= 2;
    il->array = (int*) realloc(il->array, il->capacity * sizeof(int));
}

void intlist_append(intlist* il, int i) {
    if (il->size == il->capacity) {
        intlist_increase_capacity(il);
    }
    il->array[il->size] = i;
    il->size++;
}
