/*
 * N-Body Methods
 * Copyright (C) 2006 Dustin Lang, Mike Klass, Firas Hamze, Anthony Lee
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef INTLIST_H_
#define INTLIST_H_

struct intlist {
    int* array;
    int size;
    int capacity;
};
typedef struct intlist intlist;

intlist* intlist_new();
void intlist_free(intlist* il);
int intlist_size(intlist* il);
void intlist_copy(intlist* il, int num, int* dest);
int intlist_get(intlist* il, int index);
void intlist_remove_all(intlist* il);
void intlist_append(intlist* il, int i);

#endif /*INTLIST_H_*/
