/*
 * N-Body Methods
 * Copyright (C) 2006 Dustin Lang, Mike Klass, Firas Hamze, Anthony Lee
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef KERNEL_POLYNOMIAL_
#define KERNEL_POLYNOMIAL_

void polynomial_kernel_init(double* kernel_params, int NP);

void polynomial_kernel_destroy();

double polynomial_influence(double weight, double dist);

double polynomial_distance(double* x, double* y, int D);

int polynomial_increasing();

#endif /*KERNEL_POLYNOMIAL_*/
