/*
 * N-Body Methods
 * Copyright (C) 2006 Dustin Lang, Mike Klass, Firas Hamze, Anthony Lee
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef NODELIST_H_
#define NODELIST_H_

#include "generic.h"

struct nodelist {
    Node** array;
    int size;
    int capacity;
};
typedef struct nodelist nodelist;

nodelist* nodelist_new();

int nodelist_size(nodelist* al);

void nodelist_append_list(nodelist* dest, nodelist* src);

Node* nodelist_get(nodelist* al, int index);

void nodelist_remove(nodelist* al, Node* an);

void nodelist_copy(nodelist* al, int num, Node** dest);

void nodelist_append(nodelist* al, Node* an);

void nodelist_free(nodelist* al);

void nodelist_remove_after_index(nodelist* al, int start);

#endif /*NODELIST_H_*/
