/*
 * N-Body Methods
 * Copyright (C) 2006 Dustin Lang, Mike Klass, Firas Hamze, Anthony Lee
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef PQUEUE_H_
#define PQUEUE_H_

#include "generic.h"

struct bound_node {
    Node* Ynode;
    Node* Xnode;
    double lower;
    double upper;
    double value;  //  = (upper - lower) * Ynode->N
    int order;
    struct bound_node* next;
};
typedef struct bound_node bound_node;

struct pqueue {
    bound_node** heads;
    int size;
    int num_orders;
    int hopeless;
    int max_index;
};
typedef struct pqueue pqueue;

void pq_enqueue(pqueue* pqueue, bound_node* bound_node);
bound_node* pq_pop(pqueue* pqueue);
pqueue* pq_new(int max_order, int hopeless);
void pq_print(pqueue* pq);
void pq_free(pqueue* pq);

#endif /*PQUEUE_H_*/
