MODE = "cl_cpu_by_feat"
## MODE = "cl_gpu_by_feat"

PRECISION = "FLOAT"
PRECISION = "DOUBLE"

n = 100
d = 4
X = matrix(rnorm(d*n), d, n)

NPAR = 3

OMEGA = 1e-9
theta = runif(3, c(1, -5, -5), c(6, 2, -2))
exp_theta = exp(theta)

## A = exp(theta[1]) * exp( - exp(theta[3]) * as.matrix(dist(t(X))^2)) + diag(exp(theta[2]) + 1e-9, n)
y = rnorm(n)


PRIOR.SIGMA.SHAPE = 1
PRIOR.SIGMA.RATE = 0.1
PRIOR.LAMBDA.SHAPE = 1
PRIOR.LAMBDA.RATE = 0.1
PRIOR.TAU.SHAPE = 1
PRIOR.TAU.RATE = 0.1
PRIORS = c(PRIOR.SIGMA.SHAPE, PRIOR.SIGMA.RATE, PRIOR.LAMBDA.SHAPE, PRIOR.LAMBDA.RATE, PRIOR.TAU.SHAPE, PRIOR.TAU.RATE)

gradient = rep(0, NPAR)
rvect = rep(0, n)

cat("MODE ", MODE, "  ")
cat("PRECISION ", PRECISION, "  ")


if(MODE == "cl_cpu_by_feat") {
  if(PRECISION == "FLOAT") dyn.load("wrapper_gradient_cpu_float_by_feat.so")
  if(PRECISION == "DOUBLE") dyn.load("wrapper_gradient_cpu_double_by_feat.so")
}

if(MODE == "cl_gpu_by_feat") {
  if(PRECISION == "FLOAT") dyn.load("wrapper_gradient_gpu_float_by_feat.so")
  if(PRECISION == "DOUBLE") dyn.load("wrapper_gradient_gpu_double_by_feat.so")
}

THRS_CONVERGENCE_CG = 1.0e-10
THRS_EARLY_STOP_CG = -1.0
DECAY_EARLY_STOP_CG = 100.0

running.time = system.time(assign("res", .C("wrapper_gradient", as.double(X), as.double(y), as.integer(n), as.integer(d), as.double(theta), as.double(exp_theta), as.double(OMEGA), as.double(PRIORS), as.integer(NPAR), as.double(gradient), as.double(rvect), as.double(THRS_CONVERGENCE_CG), as.double(THRS_EARLY_STOP_CG), as.double(DECAY_EARLY_STOP_CG))))

cat("Running time: ", running.time, "\n\n")

print(res[[10]])


rvect = res[[11]]



K = exp(theta[1]) * exp( - exp(theta[3]) * as.matrix(dist(t(X))^2)) + diag(exp(theta[2]) + OMEGA, n)

dKdt1 = exp(theta[1]) * exp( - exp(theta[3]) * as.matrix(dist(t(X))^2))
dKdt2 = diag(exp_theta[2], n)
dKdt3 = dKdt1 * (log(dKdt1) - theta[1])


grad_R = rep(0, 3)

grad_R[1] = - 0.5 * t(rvect) %*% solve(K) %*% dKdt1 %*% rvect + 0.5 * t(y) %*% solve(K) %*% dKdt1 %*% solve(K) %*% y + PRIOR.SIGMA.SHAPE - PRIOR.SIGMA.RATE * exp_theta[1];
grad_R[2] = - 0.5 * t(rvect) %*% solve(K) %*% dKdt2 %*% rvect + 0.5 * t(y) %*% solve(K) %*% dKdt2 %*% solve(K) %*% y + PRIOR.LAMBDA.SHAPE - PRIOR.LAMBDA.RATE * exp_theta[2];
grad_R[3] = - 0.5 * t(rvect) %*% solve(K) %*% dKdt3 %*% rvect + 0.5 * t(y) %*% solve(K) %*% dKdt3 %*% solve(K) %*% y + PRIOR.TAU.SHAPE - PRIOR.TAU.RATE * exp_theta[3];
