#pragma OPENCL EXTENSION cl_khr_fp64 : enable

__kernel void matrix_vector_multiplication_double(__global const double *X, __global const int *n, __global const int *d, __global const double *kpar, __global const double *exp_kpar, __global const double *OMEGA, __global const double *v, __global const int *split_row_matrix, __global const int *n_devices, __global const int *gpu_id, __global double *y)
{
  double diff = 0.0;
  double norm = 0.0;
  double res = 0.0;

  int private_n = *n;
  int private_d = *d;

  double private_kpar0 = kpar[0];
  double private_exp_kpar2 = exp_kpar[2];

  int i = get_global_id(0);
  int index2 = get_global_id(1);
  int itimesd = i * private_d;

  double xprivate[100];
  for(int k = 0; k < private_d; k++) {
    xprivate[k] = X[k + itimesd];
  }

  int min_index_j = private_n / *n_devices / *split_row_matrix * index2 + private_n / *n_devices * *gpu_id;
  int max_index_j = min_index_j + private_n / *n_devices / *split_row_matrix;
  if( (index2 == (*split_row_matrix - 1)) ) max_index_j = private_n / *n_devices * (*gpu_id + 1);

  int jtimesd = min_index_j * private_d;
  for(int j = min_index_j; j < max_index_j; j++, jtimesd += private_d) {
    norm = 0.0;
    for(int k = 0; k < private_d; k++) {
      diff = xprivate[k] - X[k + jtimesd];
      norm += diff * diff;
    }
    
    res += exp(-private_exp_kpar2 * norm + private_kpar0) * v[j];
  }

  y[i + index2 * private_n] = res;

}
