SHOW_ACCURACY = T

MODE = "gsl_by_data"
MODE = "gsl_by_feat"
MODE = "no_gsl_by_data"
MODE = "no_gsl_by_feat"
## MODE = "cl_cpu_by_data"
## MODE = "cl_gpu_by_data"
MODE = "cl_cpu_by_feat"
## MODE = "cl_gpu_by_feat"

PRECISION = "FLOAT"
## PRECISION = "DOUBLE"

type = which(c("gsl_by_data", "gsl_by_feat", "no_gsl_by_data", "no_gsl_by_feat", "cl_cpu_by_data", "cl_gpu_by_data", "cl_cpu_by_feat", "cl_gpu_by_feat") == MODE)

n = 1000
d = 4
X = matrix(rnorm(n*d), n, d)

OMEGA = 1e-9
theta = runif(3, c(1, -5, -5), c(6, 2, -2))
exp_theta = exp(theta)

if(SHOW_ACCURACY == T) A = exp(theta[1]) * exp( - exp(theta[3]) * as.matrix(dist(X)^2)) + diag(exp(theta[2]) + 1e-9, n)
b = sample(c(-1,1), n, replace=T)




result = runif(n)

if(MODE %in% c("gsl_by_feat", "no_gsl_by_feat", "cl_cpu_by_feat", "cl_gpu_by_feat")) X = t(X)


cat("MODE ", MODE, "  ")
cat("PRECISION ", PRECISION, "  ")

if(MODE %in% c("gsl_by_data", "gsl_by_feat", "no_gsl_by_data", "no_gsl_by_feat")) {
  dyn.load("kernel_matrix_multiplication.so")
  
  running.time = system.time(assign("res", .C("wrapper_multiply_K_vector", as.double(X), as.integer(n), as.integer(d), as.double(theta), as.double(exp_theta), as.double(OMEGA), as.double(b), as.integer(type), as.double(result))))
}


if(MODE %in% c("cl_cpu_by_data", "cl_gpu_by_data", "cl_cpu_by_feat", "cl_gpu_by_feat")) {

    if(MODE == "cl_cpu_by_data") {
        if(PRECISION == "FLOAT") dyn.load("gpu_wrapper_cpu_float_by_data.so")
        if(PRECISION == "DOUBLE") dyn.load("gpu_wrapper_cpu_double_by_data.so")
    }

    if(MODE == "cl_gpu_by_data") {
        if(PRECISION == "FLOAT") dyn.load("gpu_wrapper_gpu_float_by_data.so")
        if(PRECISION == "DOUBLE") dyn.load("gpu_wrapper_gpu_double_by_data.so")
    }

    if(MODE == "cl_cpu_by_feat") {
        if(PRECISION == "FLOAT") dyn.load("gpu_wrapper_cpu_float_by_feat.so")
        if(PRECISION == "DOUBLE") dyn.load("gpu_wrapper_cpu_double_by_feat.so")
    }

    if(MODE == "cl_gpu_by_feat") {
        if(PRECISION == "FLOAT") dyn.load("gpu_wrapper_gpu_float_by_feat.so")
        if(PRECISION == "DOUBLE") dyn.load("gpu_wrapper_gpu_double_by_feat.so")
    }
    
    running.time = system.time(assign("res", .C("wrapper_kernel_matrix_vector_multiplication", as.double(X), as.integer(n), as.integer(d), as.double(theta), as.double(exp_theta), as.double(OMEGA), as.double(b), as.integer(type), as.double(result))))
}

cat("Running time: ", running.time, "\n\n")


if(SHOW_ACCURACY == T) print(range(A %*% b - res[[9]]))
