DATASET = "concrete"

A = 0.5
B = 0.01

## ******************** DATASET
DATA = new.env()

if(DATASET == "concrete") {
  DATA$X = t(as.matrix(read.table("~/DATASET_REGRESSION/clean/concrete_X.txt")))
  DATA$y = as.matrix(read.table("~/DATASET_REGRESSION/clean/concrete_y.txt"))
}

## DATA$X = t(as.matrix(read.table("~/DATASET_REGRESSION/clean/census8L_X.txt")[1:1000,]))
## DATA$y = as.matrix(read.table("~/DATASET_REGRESSION/clean/census8L_y.txt"))[1:1000]

DATA$n = dim(DATA$X)[2]
DATA$d = dim(DATA$X)[1]

## ****************************************

OMEGA = 1e-9

NREP = 1000
## SEEDS = 1421812 + 7 * c(1:1000)
plot.condition = rep(0, NREP)

for(repetition in 1:NREP) {
  cat(repetition, "\n")
  
  ## set.seed(SEEDS[repetition])

  theta = log(rgamma(3, shape=A, rate=B))
  exp_theta = exp(theta)

  K = exp(theta[1]) * exp( - exp(theta[3]) * as.matrix(dist(t(DATA$X))^2)) + diag(exp(theta[2]) + 1e-9, DATA$n)
  lambda = eigen(K, symmetric=T, only.values=T)[[1]]
  plot.condition[repetition] = lambda[1] / lambda[DATA$n]
  
}

filesave = paste("RES_DISTRIBUTION_CONDITION_NUMBER_", DATASET, "_", A, "_", B, ".txt", sep="")

write.table(plot.condition, file = filesave, quote=F, col.names=F, row.names=F)
