#pragma OPENCL EXTENSION cl_khr_fp64 : enable

__kernel void matrix_vector_multiplication_double(__global const double *X, __global const int *n, __global const int *d, __global const double *kpar, __global const double *exp_kpar, __global const double *OMEGA, __global const double *v, __global double *y)
{
  double diff = 0.0;
  double norm = 0.0;
  int i = get_global_id(0);

  double xlocal[100];
  for(int k = 0; k < *d; k++) {
    xlocal[k] = X[i + k * *n];
  }
  

  y[i] = 0.0;
  for(int j = 0; j < *n; j++) {
    norm = 0.0;
    for(int k = 0; k < *d; k++) {
      diff = xlocal[k] - X[j + k * *n];
      norm += diff * diff;
    }
  y[i] += exp(-exp_kpar[2] * norm + kpar[0]) * v[j];
  }

}
