__kernel void matrix_vector_multiplication_float(__global const float *X, __global const int *n, __global const int *d, __global const float *kpar, __global const float *exp_kpar, __global const float *OMEGA, __global const float *v, __global float *y)
{
  float diff = 0.0;
  float norm = 0.0;
  int i = get_global_id(0);

  float xlocal[100];
  for(int k = 0; k < *d; k++) {
    xlocal[k] = X[i + k * *n];
  }

  y[i] = 0.0;
  for(int j = 0; j < *n; j++) {
    norm = 0.0;
    for(int k = 0; k < *d; k++) {
      diff = xlocal[k] - X[j + k * *n];
      norm += diff * diff;
    }
  y[i] += exp(-exp_kpar[2] * norm + kpar[0]) * v[j];
  }

}
