ps.options(width=20, height=5, paper="special", horizontal=F, pointsize=40)

DATASET = "concrete"

AB = matrix(0, 5, 2)
AB[1,] = c(1,1)
AB[2,] = c(1,0.1)
AB[3,] = c(1,0.01)
AB[4,] = c(0.5,0.01)
AB[5,] = c(0.3,0.01)

plot.matrix = matrix(0, 1000, dim(AB)[1])

for(i in 1:(dim(AB)[1])) {

  filesave = paste("RES_DISTRIBUTION_CONDITION_NUMBER_", DATASET, "_", AB[i,1], "_", AB[i,2], ".txt", sep="")
  
  tmp = as.matrix(read.table(filesave))

  plot.matrix[,i] = tmp
}

## ************** N ITERATIONS vs CONDITION NUMBER
postscript("PLOT_DISTRIBUTION_CONDITION_NUMBER.eps")
par("mar"=c(3.0,0.1,0.1,0.1), "mgp"=c(1.8,0.6,0))

## tmp = density(log(log10(plot.matrix[,1])))
## tmp$x = exp(tmp$x)
## tmp$y = tmp$y / tmp$x

NAMES_TICK = c(paste("a = ", AB[1,1], ", b = ", AB[1,2], sep = ""), paste("a = ", AB[2,1], ", b = ", AB[2,2], sep = ""), paste("a = ", AB[3,1], ", b = ", AB[3,2], sep = ""), paste("a = ", AB[4,1], ", b = ", AB[4,2], sep = ""))

boxplot(log10(plot.matrix[,-5]), horizontal=T, xlab=expression(log[10](symbol(k))), ylab="", pch="", range=0, names = NULL, xlab=expression(log[10](symbol(k))), yaxt="n", ylim=c(0, 12))

text(8, 1.0, NAMES_TICK[1], adj=c(0,0.5))
text(8, 2.0, NAMES_TICK[2], adj=c(0,0.5))
text(8, 3.0, NAMES_TICK[3], adj=c(0,0.5))
text(8, 4.0, NAMES_TICK[4], adj=c(0,0.5))

dev.off()

## for(i in 1:3) {
##   ## tmp = density(log(log10(plot.matrix[,i+1])))
##   ## tmp$x = exp(tmp$x)
##   ## tmp$y = tmp$y / tmp$x

## tmp = density(log10(plot.matrix[,i+1]))
## tmp$y = tmp$y * (1 / (1 + exp(-30 * tmp$x)))
  
##   points(tmp, type="l", col=i + 1)
## }
## legend(5, 2, c(paste(AB[1,1], AB[1,2], sep=" "), paste(AB[2,1], AB[2,2], sep=" "), paste(AB[3,1], AB[3,2], sep=" "), paste(AB[4,1], AB[4,2], sep=" ")), col=c(1:4), lwd=2, cex=1)
## dev.off()
