SHOW_ACCURACY = T

MODE = "cl_cpu_by_feat"
## MODE = "cl_gpu_by_feat"

## PRECISION = "FLOAT"
PRECISION = "DOUBLE"

n = 1000
d = 4
X = matrix(rnorm(d*n), d, n)

OMEGA = 1e-9
theta = runif(3, c(1, -5, -5), c(6, 2, -2))
exp_theta = exp(theta)

if(SHOW_ACCURACY == T) A = exp(theta[1]) * exp( - exp(theta[3]) * as.matrix(dist(t(X))^2)) + diag(exp(theta[2]) + 1e-9, n)
b = sample(c(-1,1), n, replace=T)

n_results = 10
result = matrix(0, n, n_results)


cat("MODE ", MODE, "  ")
cat("PRECISION ", PRECISION, "  ")


if(MODE == "cl_cpu_by_feat") {
  if(PRECISION == "FLOAT") dyn.load("wrapper_linear_system_cpu_float_by_feat.so")
  if(PRECISION == "DOUBLE") dyn.load("wrapper_linear_system_cpu_double_by_feat.so")
}

if(MODE == "cl_gpu_by_feat") {
  if(PRECISION == "FLOAT") dyn.load("wrapper_linear_system_gpu_float_by_feat.so")
  if(PRECISION == "DOUBLE") dyn.load("wrapper_linear_system_gpu_double_by_feat.so")
}

THRS_CONVERGENCE_CG = 1.0e-10
THRS_EARLY_STOP_CG = 1.0
DECAY_EARLY_STOP_CG = 100.0

running.time = system.time(assign("res", .C("wrapper_linear_system", as.double(X), as.integer(n), as.integer(d), as.double(theta), as.double(exp_theta), as.double(OMEGA), as.double(b), as.integer(n_results), as.double(result), as.double(THRS_CONVERGENCE_CG), as.double(THRS_EARLY_STOP_CG), as.double(DECAY_EARLY_STOP_CG))))

cat("Running time: ", running.time, "\n\n")



if(SHOW_ACCURACY == T) {
  true.res = solve(A, b)

  for(i in 1:n_results) {
      print(range(true.res - res[[9]][(1:n) + (i - 1) * n]))
  }
}
