ps.options(width=10, height=5, paper="special", horizontal=F, pointsize=35)

opt <- options("scipen" = -1)

running_mean = function(x, epsilon) {
  cumsum(x * epsilon) / cumsum(epsilon)
}

running_sd = function(x, epsilon) {
  sqrt(running_mean( ( x - running_mean(x, epsilon) )^2, epsilon))
}


NBURNIN.MCMC = 10000

epsilon.plot = as.matrix(read.table("RES_SMALL_DATA_COMPARISON_MCMC_SGR/SAMPLES_EPSILON_SEED_2.txt"))
NBURNIN.SGR = iteration_freeze_epsilon = min(which(diff(epsilon.plot) == 0))

NBURNIN.SGR = max(NBURNIN.SGR, length(epsilon.plot) - 40000)

## par(mfrow=c(2,3))

postscript("PLOT_COMPARE_SGR_MCMC_psi_sigma.eps")

par("mar"=c(3.0,3.0,1.1,1), "mgp"=c(1.8,0.6,0))

psi.sigma.mcmc = as.matrix(read.table("RES_SMALL_DATA_COMPARISON_MCMC_SGR/psi.sigma_mcmc_out.txt"))[-c(1:NBURNIN.MCMC)]
psi.sigma.sgr = as.matrix(read.table("RES_SMALL_DATA_COMPARISON_MCMC_SGR/psi.sigma_sgr_out.txt"))[-c(1:NBURNIN.SGR)]

xxx = c(1:length(psi.sigma.sgr))
ind.subset = which((xxx %% 20) == 0)

YLIM = c(1.3, 3.5)
YLIM = c(1, 4)
plot(xxx[ind.subset], running_mean(psi.sigma.sgr,  c(1:length(psi.sigma.sgr)))[ind.subset], type="l", col=1, ylim = YLIM, lwd = 2, ylab=expression(log(sigma)), xlab="Iteration number")
points(xxx[ind.subset], (running_mean(psi.sigma.sgr,  c(1:length(psi.sigma.sgr))) + 2 * running_sd(psi.sigma.sgr,  c(1:length(psi.sigma.sgr))))[ind.subset], type="l", col=1, lwd = 2)
points(xxx[ind.subset], (running_mean(psi.sigma.sgr,  c(1:length(psi.sigma.sgr))) - 2 * running_sd(psi.sigma.sgr,  c(1:length(psi.sigma.sgr))))[ind.subset], type="l", col=1, lwd = 2)
points(xxx[ind.subset], psi.sigma.sgr[ind.subset], type="l", lty=2, col="gray50")

xxx = c(1:length(psi.sigma.mcmc))
ind.subset = which((xxx %% 20) == 0)

points(xxx[ind.subset], running_mean(psi.sigma.mcmc, c(1:length(psi.sigma.mcmc)))[ind.subset], type="l", ylim = YLIM, lwd = 1, col=2)
points(xxx[ind.subset], (running_mean(psi.sigma.mcmc, c(1:length(psi.sigma.mcmc))) + 2 * running_sd(psi.sigma.mcmc, c(1:length(psi.sigma.mcmc))))[ind.subset], type="l", lwd = 1, col=2)
points(xxx[ind.subset], (running_mean(psi.sigma.mcmc, c(1:length(psi.sigma.mcmc))) - 2 * running_sd(psi.sigma.mcmc, c(1:length(psi.sigma.mcmc))))[ind.subset], type="l", lwd = 1, col=2)
## points(psi.sigma.mcmc, type="l", lty=2)

## points(running_mean(psi.sigma.sgr, c(1:length(psi.sigma.sgr))), type="l", col=2)
## points(running_mean(psi.sigma.sgr, c(1:length(psi.sigma.sgr))) + 2 * running_sd(psi.sigma.sgr, c(1:length(psi.sigma.sgr))), type="l", col=2)
## points(running_mean(psi.sigma.sgr, c(1:length(psi.sigma.sgr))) - 2 * running_sd(psi.sigma.sgr, c(1:length(psi.sigma.sgr))), type="l", col=2)

dev.off()


postscript("PLOT_COMPARE_SGR_MCMC_psi_lambda.eps")

par("mar"=c(3.0,3.0,1.1,1), "mgp"=c(1.8,0.6,0))

psi.lambda.mcmc = as.matrix(read.table("RES_SMALL_DATA_COMPARISON_MCMC_SGR/psi.lambda_mcmc_out.txt"))[-c(1:NBURNIN.MCMC)]
psi.lambda.sgr = as.matrix(read.table("RES_SMALL_DATA_COMPARISON_MCMC_SGR/psi.lambda_sgr_out.txt"))[-c(1:NBURNIN.SGR)]

xxx = c(1:length(psi.lambda.sgr))
ind.subset = which((xxx %% 20) == 0)

YLIM = c(-2.95,-2.45)
YLIM = c(-2.9,-2.4)
plot(xxx[ind.subset], running_mean(psi.lambda.sgr, c(1:length(psi.lambda.sgr)))[ind.subset], type="l", col=1, ylim = YLIM, lwd = 2, ylab=expression(log(lambda)), xlab="Iteration number")
points(xxx[ind.subset], (running_mean(psi.lambda.sgr, c(1:length(psi.lambda.sgr))) + 2 * running_sd(psi.lambda.sgr, c(1:length(psi.lambda.sgr))))[ind.subset], type="l", col=1, lwd = 2)
points(xxx[ind.subset], (running_mean(psi.lambda.sgr, c(1:length(psi.lambda.sgr))) - 2 * running_sd(psi.lambda.sgr, c(1:length(psi.lambda.sgr))))[ind.subset], type="l", col=1, lwd = 2)
points(xxx[ind.subset], psi.lambda.sgr[ind.subset], type="l", lty=2, col="gray50")

xxx = c(1:length(psi.lambda.mcmc))
ind.subset = which((xxx %% 20) == 0)

points(xxx[ind.subset], running_mean(psi.lambda.mcmc, c(1:length(psi.lambda.mcmc)))[ind.subset], type="l", ylim = YLIM, lwd = 1, col=2)
points(xxx[ind.subset], (running_mean(psi.lambda.mcmc, c(1:length(psi.lambda.mcmc))) + 2 * running_sd(psi.lambda.mcmc, c(1:length(psi.lambda.mcmc))))[ind.subset], type="l", lwd = 1, col=2)
points(xxx[ind.subset], (running_mean(psi.lambda.mcmc, c(1:length(psi.lambda.mcmc))) - 2 * running_sd(psi.lambda.mcmc, c(1:length(psi.lambda.mcmc))))[ind.subset], type="l", lwd = 1, col=2)
## points(psi.lambda.mcmc, type="l", lty=2)


## points(running_mean(psi.lambda.sgr, c(1:length(psi.lambda.sgr))), type="l", col=2)
## points(running_mean(psi.lambda.sgr, c(1:length(psi.lambda.sgr))) + 2 * running_sd(psi.lambda.sgr, c(1:length(psi.lambda.sgr))), type="l", col=2)
## points(running_mean(psi.lambda.sgr, c(1:length(psi.lambda.sgr))) - 2 * running_sd(psi.lambda.sgr, c(1:length(psi.lambda.sgr))), type="l", col=2)

dev.off()


postscript("PLOT_COMPARE_SGR_MCMC_psi_tau.eps")

par("mar"=c(3.0,3.0,1.1,1), "mgp"=c(1.8,0.6,0))

YLIM = c(-3.4,-2.1)
YLIM = c(-3.6,-2.0)
psi.tau.mcmc = as.matrix(read.table("RES_SMALL_DATA_COMPARISON_MCMC_SGR/psi.tau_mcmc_out.txt"))[-c(1:NBURNIN.MCMC)]
psi.tau.sgr = as.matrix(read.table("RES_SMALL_DATA_COMPARISON_MCMC_SGR/psi.tau_sgr_out.txt"))[-c(1:NBURNIN.SGR)]

xxx = c(1:length(psi.tau.sgr))
ind.subset = which((xxx %% 20) == 0)

plot(xxx[ind.subset], running_mean(psi.tau.sgr, c(1:length(psi.tau.sgr)))[ind.subset], type="l", col=1, ylim = YLIM, lwd = 2, ylab=expression(log(tau)), xlab="Iteration number")
points(xxx[ind.subset], (running_mean(psi.tau.sgr, c(1:length(psi.tau.sgr))) + 2 * running_sd(psi.tau.sgr, c(1:length(psi.tau.sgr))))[ind.subset], type="l", col=1, lwd = 2)
points(xxx[ind.subset], (running_mean(psi.tau.sgr, c(1:length(psi.tau.sgr))) - 2 * running_sd(psi.tau.sgr, c(1:length(psi.tau.sgr))))[ind.subset], type="l", col=1, lwd = 2)
points(xxx[ind.subset], psi.tau.sgr[ind.subset], type="l", lty=2, col="gray50")

xxx = c(1:length(psi.tau.mcmc))
ind.subset = which((xxx %% 20) == 0)

points(xxx[ind.subset], running_mean(psi.tau.mcmc, c(1:length(psi.tau.mcmc)))[ind.subset], type="l", ylim = YLIM, lwd = 1, col=2)
points(xxx[ind.subset], (running_mean(psi.tau.mcmc, c(1:length(psi.tau.mcmc))) + 2 * running_sd(psi.tau.mcmc, c(1:length(psi.tau.mcmc))))[ind.subset], type="l", lwd = 1, col=2)
points(xxx[ind.subset], (running_mean(psi.tau.mcmc, c(1:length(psi.tau.mcmc))) - 2 * running_sd(psi.tau.mcmc, c(1:length(psi.tau.mcmc))))[ind.subset], type="l", lwd = 1, col=2)
## points(psi.tau.mcmc, type="l", lty=2)

## points(running_mean(psi.tau.sgr, c(1:length(psi.tau.sgr))), type="l", col=2)
## points(running_mean(psi.tau.sgr, c(1:length(psi.tau.sgr))) + 2 * running_sd(psi.tau.sgr, c(1:length(psi.tau.sgr))), type="l", col=2)
## points(running_mean(psi.tau.sgr, c(1:length(psi.tau.sgr))) - 2 * running_sd(psi.tau.sgr, c(1:length(psi.tau.sgr))), type="l", col=2)

dev.off()


## GRADIENTS = as.matrix(read.table("RES_SMALL_DATA_COMPARISON_MCMC_SGR/SAMPLES_GRAD_SEED_1.txt"))

library(coda)

allchains = list()

for(i in 1:9) {
  allchains[[i]] = mcmc(as.matrix(read.table(paste("RES_SMALL_DATA_COMPARISON_MCMC_SGR/SAMPLES_SEED_", i, ".txt", sep="")))[3000:40000,])
}

x11()
zz = gelman.plot(allchains, autoburnin=F)
dev.off()

FILENAME = c("PLOT_PSRF_CONCRETE_psi_sigma.eps", "PLOT_PSRF_CONCRETE_psi_lambda.eps", "PLOT_PSRF_CONCRETE_psi_tau.eps")
YLAB = c(expression(log(sigma)), expression(log(lambda)), expression(log(tau)))
for(iii in 1:3) {

  postscript(FILENAME[iii])

  par("mar"=c(3.0,3.0,1.1,1), "mgp"=c(1.8,0.6,0))

  plot(zz$last.iter, zz[[1]][,iii,2], type="l", col=2, lty=2, lwd=2, ylim=c(1, 4), xlab="Iteration number", ylab=YLAB[iii])## ylim = c(1, max(zz[[1]][,iii,2])))
  points(zz$last.iter, zz[[1]][,iii,1], type="l", col=1, lty=1, lwd=2)
  abline(h=1)

  legend(15000, 4, c("PSRF median", "PSRF 97.5%"), lwd=2, lty=c(1, 2), col=c(1,2), cex=0.8)
  
  dev.off()
}


## DIAG_G = as.matrix(read.table("RES_SMALL_DATA_COMPARISON_MCMC_SGR/TMP_RES_DIAG_G.txt"))

## EIG_COV_GRAD = rep(0, (dim(GRADIENTS)[1]-1000))
## for(i in 1:(dim(GRADIENTS)[1] - 1000)) {
##   M = diag(1/sqrt(DIAG_G[i + 1000,]))

##   V = cov(GRADIENTS[1:1000 + i,])
  
##   EIG_COV_GRAD[i] = eigen( cov(sqrt(M) %*% V %*% sqrt(M)), only.values=T )[[1]][1]
## }

## ## plot(EIG_COV_GRAD * c(rep(EMAX, NADAPTIVE-1000), epsilon.plot) / 4, ylim=c(0,1))
## plot(EIG_COV_GRAD * epsilon.plot[-c(1:1001)] / 4, ylim=c(0,1))
